# coding: utf-8

from __future__ import absolute_import
from __future__ import division
from __future__ import unicode_literals

from typing import Tuple, Optional, AnyStr

class PortRange(object):
    __slots__: Tuple[str]

    def __init__(self, lower_port: int, upper_port: Optional[int]=None):
        self.lower_port: int = ...
        self.upper_port: int = ...

    def __str__(self) -> str: ...

    @classmethod
    def from_str(cls, s: AnyStr) -> PortRange: ...
